### [1.7.5] - 2021-07-01 ###
#### Changes ####
  * Changed DISPEL_FAILED event to use its own 'DISPEL_FAIL' ('DSF') extended event
    * Note: This is to distinguish it from other 'MISS' events which don't include the $xspell token

### [1.7.4] - 2021-06-24 ###
#### Additions ####
  * Added aliases 'b', 'nb', 'm', 'nm' for 'button', 'nobutton', 'modifier' and 'nomodifier' respectively
  * Added aliases 's', 'ls', 'rs', 'c', 'lc', 'rc', 'a', 'la', 'ra' for 'shift', 'ctrl', 'alt' and their left / right variants

#### Changes ####
  * Changed dynamic unit condition logic to prevent incorrect output when switching targets
  * Changed DISPEL_FAILED event to report as a 'MISS' event

### [1.7.3] - 2021-06-14 ###
#### Fixes ####
  * Fixed a bug that caused the FAILED_LOSSOFCONTROL event not to trigger

### [1.7.2] - 2021-06-12 ###
#### Fixes ####
  * Fixed a loading error with new installs. Sorry.

### [1.7.1] - 2021-06-12 ###
#### Fixes ####
  * Fixed $time and $delay values for channeled spells in BCC
  
#### Changes ####
  * Changed how spell names are registered to prevent non-matching capitalisation
  * Changed behaviour of the MISS event so it no longer prevents AoEs from triggering multiple events

### [1.7.0] - 2021-06-10 ###
#### Features and Additions ####
  * Added dynamic unit evaluation for unit conditions when no @unit is specified. This is mostly useful for multi-target macros. See Readme for details.   
  * Added 'nohelp' and 'noharm' unit conditions for macros
  * Added '@t' '@mo' '@f' '@tt' and '@p' unit aliases for @target, @mouseover, @focus, @targettarget and @player respectively
  * Added 'FAILED_COOLDOWN' and 'FAILED_LOSSOFCONTROL' special events that override the standard FAILED event in case of failure due to spell cooldown and loss of control (e.g. stunned) respectively. See Readme for details.
  * Added $cooldown, $cd to output tokens for cooldown and loss of control failure events

#### Changes ####
  * Loss of control reasons due to mechanics now tagged with {Mechanic}

#### Fixes ####
  * Implemented logic so self dispel now works for the EFFECT event
  * Fixed a bug that prevented extended events from being registered via /oncast-spell

### [1.6.0] - 2020-11-27 ###
#### Refinement Update ####
  * Macro command now accepts multiple sets of: events channels message
  * Short aliases for channels, events, extended events and message tokens
  * Short alias for macro command: /oc-m

#### Additions ####
  * RAID10, RAID20 and RAIDPARTY channels for more selective output in raids
  * Macro Condition 'dead'
  * Awareness of more Loss Of Control failure reasons such as Banished, Disarmed, Polymorphed, and Possessed

#### Changes ####
  * CLogMonitor name changed to ExtendedEvents (game restart required)
  * PVP channel is now 'BATTLEGROUND' to differentiate types of 'INSTANCE_CHAT'
  * PARTY channel no longer outputs to party in a raid; use RAIDPARTY

#### Fixes ####
  * Added a check for self cast heal and aura spell names to prevent mix-ups under certain conditions
  * Added a check that the target name matches the @unit name (if set).. helps prevent mix-ups for selective targeting macros
  * Fix to completely remove a spell when all of its events have been removed

### [1.5.2] - 2020-10-29 ###
#### Fixes ####
  * Fixed a bug where 'help' and 'version' were a sub-command of /oncast-m instead of /oncast
  * Fixed 'Shoot' and 'Throw' type abilities from showing debug for extended events

### [1.5.1] - 2020-10-25 ###
#### Fixes ####
  * Implimented logic so self heals and buffs now work for HIT and EFFECT events
  * Fixed error on debug of extended events for resurrect, summon and create
  * Fixed resurrection of a ghost using 'Unknown' target instead of @unit if specified

### [1.5.0] - 2020-10-21 ###
#### Fixes ####
  * Added UnitExists check before setting @unit as the target
  * Improved Counterspell EXTRA now works even if a cast isn't interrupted

#### Additions ####
  * EXTRA now accepts spellId. Note: The effect is still matched by name due to API limitations.

### [1.5.0b] - 2020-10-18 ###
#### Major Update ####
  * Added events:
    * HIT - Damage or Healing, can be limited to just Crits and / or a minimum value
    * EFFECT - Any special effects such as buffs, debuffs, interrupts, dispels, power gain, etc.
    * EXTRA - An Extra effect, by name of spell id, such as Fire Vulnerability from Improved Scorch
    * MISS - Missed, Resisted, Parried, Dodged, Immune, etc. etc.
  * Additional $tokens for new events:
    * $xspell - Additional spell effected, e.g. "Interrupted $xspell" or "Dispelled $xspell"
    * $amount - Amount of damage, heal, or buff stacks added (default to 1 even for non stacking buffs)
    * $xtype - The type of Aura ("Buff" or "Debuff") or power gained (e.g. "Mana", "Rage", "Energy")

#### Changes ####
  * $event output is now upper case. Suggested usage: "$event: ..."
  * Failure $reason is now based on the combat log and so is much more granular and accurate
  * Spell names can now contain an _ (underscore) in place of a space
  * Various small bug fixes and improvements


### [1.4.2] - 2020-10-15 ###
#### Additions ####
  * Implimented DELAYED event for channelled spells via SPELLCAST_CHANNEL_UPDATE

#### Changes ####
  * The $delay value for channelled spells is now positive; i.e. not longer has a - (minus) sign

### [1.4.1] - 2020-10-13 ###
#### Feature Update ####
  * Conditions can now include an @unit as a first condition; e.g. [@mouseover,...]
  * The raid target marker of the @unit can be output to standard channels with $rt

#### Additions ####
  * Conditions: exists, nodead, harm, and help check status for the specified @unit

#### Changes ####
  * $target now defaults to 'Unknown' if target value is nil


### [1.3.0] - 2020-10-12 ##
#### Performance Update ####
  * Parts of macro commands are now cached, making macros significantly faster to run
  * /oncast-m now runs the same logic as /oncast, and so will now generate meaningful errors

#### Additions ####
  * Parrot scroll area names can now use an _ (underscore) in place of a space; e.g. Scroll_Area

#### Changes ####
  * Delays of less than 0.05s are no longer displayed (helps prevent delay spam)
  * Only one failed event per cast will be displayed (helps prevent spam)

#### Fixes ####
  * Cannibalize channel effect STARTED event giving an error due to using a different spellId
  * Current cast failing (e.g. target walks out of range) not setting $reason


### [1.2.0] - 2020-10-09 ##
#### Major Update ####
  * Reworked Event handling to deal with arbitrary SPELLCAST_SENT events
  * Added 'EMOTE' standard (public) channel

#### Changes ####
  * Moved Debug to it's own command: /oncast-debug

#### Additions ####
  * Help now includes topics; e.g. /oncast help tokens
  * Parrot extended channel now accepts _ (underscore) as 'default' var value


### [1.1.3] - 2020-10-05 ##
#### Fixes ####
  * Bug where attempting to cast while already casting could cause a permanent 'busy casting' state

### [1.1.2] - 2020-10-04 ##
#### Fixes ####
  * Bug when removing a channel from a registered spell causing other channels not to work

### [1.1.1] - 2020-10-03 ##
#### Fixes ####
  * A few calls to global functions instead of the local reference
  * Parrot color error when specifying more than 3 vars
  * Parrot outline values


### [1.1.0] - 2020-10-03 ##
#### Feature Update ####
  * Message tokens can now be of the form ${token}; e.g. "${spell}ing $target"
  * Support of macro conditional keys: btn:1-5, mod:shift/ctrl/alt, nobtn, and nomod versions

#### Additions ####
  * Loss of Control (stun, fear, etc.) detection for failure $reason

#### Fixes ####
  * Clearing of macro messages if spell targeting is cancelled
  * Spells on the ignore list (e.g. Shoot) can no longer be registered

### [1.0.2] - 2020-10-02 ##
#### Fixes ####
  * /oncast-m and /oncast-spell not having a local n :/

### [1.0.1] - 2020-10-02 ##
#### Fixes ####
  * Fix for PvP (battleground) chat output

### [1.0.0] - 2020-10-01 ##
#### Initial Release

#### Features ####
  * /oncast macro command 
  * /oncast-m macro command without validation
  * /oncast-spell for registering spells by name or id
  * Info extended channel for print to default chat window
  * Parrot extended channel for output to Parrot 2
